#include <afx.h>
#include <afxdb.h>
#include <winnt.h>
#include <winbase.h>


// #define HACK

class myRS : public CRecordset
{
public:
    DECLARE_DYNAMIC(myRS);

    myRS(CDatabase* pdb = NULL)
        : CRecordset(pdb)
    {
        int cnt = 0;
        m_c1 = 0; cnt++;
        m_c8 = ""; cnt++;
        m_c9 = ""; cnt++;
#ifdef HACK
        m_c40 = ""; cnt++;
#endif

        m_nFields = cnt;
    }
    virtual void DoFieldExchange(CFieldExchange* pFX)
    {
        pFX->SetFieldType(CFieldExchange::outputColumn);
        RFX_Long(pFX, _T("[c1]"), m_c1);
        RFX_Text(pFX, _T("[c8]"), m_c8);
        RFX_Text(pFX, _T("[c9]"), m_c9);
#ifdef HACK
        RFX_Text(pFX, _T("[c40]"), m_c40);
#endif
    }
    virtual CString GetDefaultConnect()
    {
        return "ODBC;DSN=test1";
    }
    virtual CString GetDefaultSQL()
    {
#ifdef HACK
        return _T("SELECT c1,c8,c9,c40 FROM tab2");
#else
        return _T("SELECT c1,c8,c9 FROM tab2");
#endif
    }

    long       m_c1;
    CString    m_c8;
    CString    m_c9;
    CString    m_c40;
};
IMPLEMENT_DYNAMIC(myRS, CRecordset);

//----------------------------------------------------------------
int main(int argc, char ** argv)
{
                                // cannot update table
                                // Build WHERE -> insert_fields() failed.

    LPCSTR             locus = "";
    try{
        CDatabase  * db = new CDatabase();
        db->OpenEx("DSN=test1", CDatabase::noOdbcDialog); printf("opendb\n");

        myRS  *  t1 = new myRS(db);
        t1->Open(); printf("t1.open\n");

        t1->Edit();

        srand(time(NULL));
        t1->m_c8.Format("%d", long(rand()));

        printf("before-update\n"); time_t start=time(NULL);
        t1->Update();
        printf("after-update dur=%d\n", time(NULL)-start);

        t1->Close();

        delete db;
        printf("OK\n");
    }catch(CException  * ee){
        char      buff[256];
        ee->GetErrorMessage(buff, sizeof buff);
        printf("ERROR %s - %s\n", locus, buff);
        ee->Delete();
        return 1;
    }

    return 0;
}
